<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <div class="row d-flex justify-content-center">
        <div class="text-capitalize actions-icon-btn" ngbDropdown *ngIf="folioSelected">
            <button mat-stroked-button class="btn-block" color="primary" ngbDropdownToggle>
                <i class="fas fa-user mr-2"></i>
                <span class="p-2">
                    <strong>{{ folioSelected.hapellido }} {{ folioSelected.hnombre }}</strong>
                </span>
            </button>
            <div ngbDropdownMenu>
                <div class="card no-shadow rm-border bg-transparent widget-chart text-right d-none d-lg-block">
                    <ul class="rm-list-borders rm-list-borders-scroll list-group list-group-flush">
                        <li class="list-group-item bg-transparent" *ngIf="folioTdc">
                            <div class="widget-content p-0">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left mr-3">
                                        <div class="widget-heading">T.D.C.</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <div class="fsize-1 text-focus">
                                            <span>{{ folioTdc }}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item bg-transparent">
                            <div class="widget-content p-0">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left mr-3">
                                        <div class="widget-heading">Agencia</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <div class="fsize-1 text-focus">
                                            <span>{{ folioSelected.Agencia }}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item bg-transparent">
                            <div class="widget-content p-0">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left mr-3">
                                        <div class="widget-heading">Empresa</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <div class="fsize-1 text-focus">
                                            <span>{{ folioSelected.Empresa}}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>
                        <li class="list-group-item bg-transparent">
                            <div class="widget-content p-0">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left mr-3">
                                        <div class="widget-heading">Grupo</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <div class="fsize-1 text-focus">
                                            <span>{{ folioSelected.grupo }}</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>
                    </ul>
                </div>
            </div>

            <li class="list-group-item bg-transparent p-2">
                <div class="widget-content p-0">
                    <div class="widget-content-wrapper">
                        <div class="widget-content-left mr-3">
                            Descripción secundaria
                        </div>
                        <div class="widget-content-right">
                            <kendo-switch [(ngModel)]="descSecundaria" [ngModelOptions]="{standalone: true}"
                                [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
                        </div>
                    </div>
                </div>
            </li>
            <li class="list-group-item bg-transparent p-2">
                <div class="widget-content p-0">
                    <div class="widget-content-wrapper">
                        <div class="widget-content-left mr-3">
                            Desglosar paquetes
                        </div>
                        <div class="widget-content-right">
                            <kendo-switch [(ngModel)]="desglosarPaquetes" [ngModelOptions]="{standalone: true}"
                                [onLabel]="'Si'" [offLabel]="'No'" (valueChange)="getSaldos()">
                            </kendo-switch>
                        </div>
                    </div>
                </div>
            </li>
        </div>

        <div class="card no-shadow rm-border bg-transparent widget-chart text-right"
            *ngIf="folioSelected && folioSelected.hfolio">
            <div class="widget-chart-content">
                <div class="widget-subheading">Folio
                    <strong class="text-primary"> #{{ folioSelected.hfolio }} </strong>
                    <strong class="ml-2">
                        <i class="fas fa-bed mr-1"></i>{{ folioSelected.cuarto }}
                    </strong>
                    <small class="text-danger ml-2" *ngIf="folioSelected.hfsal === fday">
                        <strong>Sale Hoy!!!</strong>
                    </small>
                    <small class="text-danger ml-2" *ngIf="folioSelected.hfsal !== fday">
                        <strong>No Sale Hoy!!! </strong>
                    </small>
                </div>
                <div class="widget-numbers text-success">
                    <span>{{ saldoTotal | currency: 'MXN' }}</span>
                    <span class="ml-2" style="font-size: 1.5rem;">{{ folioSelected.hfp }}</span>
                </div>
                <div class="col d-flex justify-content-end" *ngIf="!inFolio">
                    <button class="btn btn-shadow btn-info" (click)="btnBuscarFolio()" *ngIf="flagSaldos">
                        <i class="fas fa-search mr-2"></i>Buscar Huesped
                    </button>
                    <!-- REGRESAR A SALDOS -->
                    <button class="btn btn-shadow btn-secondary ml-1" (click)="reiniciarBanderas(); this.getSaldos();"
                        *ngIf="!flagSaldos">
                        <i class="fas fa-arrow-left mr-2"></i>Regresar
                    </button>
                </div>
            </div>
        </div>

    </div>
</app-page-title>

<mat-progress-bar mode="indeterminate" *ngIf="loading" class="m-1"></mat-progress-bar>

<div class="card pb-2">
    <div class="row animated fadeIn my-1" *ngIf="flagSaldos && folioSelected && folioSelected.hfolio">
        <div class="d-flex justify-content-start col">
            <!-- <button class="btn btn-outline-secondary m-1 col" (click)="openHelp('Huesped', 'xl')">
                <i class="fas fa-bed mr-2"></i>Huesped
            </button> -->
            <button class="btn btn-outline-dark col mx-1" (click)="openHelp('Mensajes')">
                <i class="fas mr-2" [ngClass]="'Mensajes' | icon"></i><small>Mensajes</small>
                <span class="badge badge-warning ml-2" *ngIf="lmensajes">
                    <i class="fas fa-bell"></i>
                </span>
            </button>
            <button class="btn btn-outline-dark col mr-1" (click)="openHelp('Notas')">
                <i class="fas mr-2" [ngClass]="'Notas' | icon"></i><small>Notas</small>
                <span class="badge badge-warning ml-2" *ngIf="lnotas">
                    <i class="fas fa-bell"></i>
                </span>
            </button>
            <button class="btn btn-outline-dark col mr-1" (click)="openHelp('Requerimientos')">
                <i class="fas mr-2" [ngClass]="'Requerimientos' | icon"></i><small>Requerimientos</small>
                <span class="badge badge-warning ml-2" *ngIf="lreqesp">
                    <i class="fas fa-bell"></i>
                </span>
            </button>
            <button class="btn btn-outline-dark col mr-1" (click)="openHelp('Cargos')">
                <i class="fas mr-2" [ngClass]="'Cargos' | icon"></i><small>Cargos</small>
                <span class="badge badge-warning ml-2" *ngIf="lcargos">
                    <i class="fas fa-bell"></i>
                </span>
            </button>
            <button class="btn btn-outline-dark col mr-1" (click)="openHelp('Cuentas')">
                <i class="fas mr-2" [ngClass]="'Cuentas' | icon"></i><small>Cuentas</small>
            </button>
            <button class="btn btn-outline-dark col mr-1" (click)="openHelp('Cxc')" *ngIf="!consulta">
                <i class="fas mr-2" [ngClass]="'C x C' | icon"></i><small>C x C</small>
            </button>
        </div>
    </div>
    <!-- SALDOS Y CUENTAS -->
    <ng-container *ngIf="flagSaldos && dataBalances.length">
        <div class="divider"></div>
        <!-- ACCIONES PARA VISUALIZAR LA CUENTA -->
        <div class="row animated fadeIn">
            <div class="d-flex justify-content-start col-sm-12 col-md-7 col-lg-6">
                <button class="btn m-1" (click)="seleccionarVista('D')"
                    [ngClass]="{'btn-light': vistaSelected !== 'D', 'btn-success': vistaSelected === 'D'}">
                    Detallada
                </button>
                <button class="btn m-1" (click)="seleccionarVista('S')"
                    [ngClass]="{'btn-light': vistaSelected !== 'S', 'btn-success': vistaSelected === 'S'}">
                    Sumarizada
                </button>
                <button class="btn m-1" (click)="seleccionarVista('R')"
                    [ngClass]="{'btn-light': vistaSelected !== 'R', 'btn-success': vistaSelected === 'R'}">
                    Resumen
                </button>
                <button class="btn btn-light m-1" (click)="crearPreimpreso()" [disabled]="!dataGrid.length || loading"
                    *ngIf="!consulta">
                    <i class="fas fa-receipt mr-2"></i>Preimpreso
                </button>
                <button class="btn btn-light m-1" (click)="openModal(modalFact, 'xl')" *ngIf="!consulta"
                    [disabled]="!dataGrid.length || cuentaSelected.lfactura || cuentaSelected.dbalance !== 0 || loading">
                    <i class="fas fa-file-invoice-dollar mr-2"></i> Factura
                </button>
            </div>
            <div class="d-flex justify-content-end col-sm-12 col-md-5 col-lg-6">
                <button class="btn btn-primary mr-1" (click)="entradaMovimiento(modalDetMov)"
                    [disabled]="cuentaSelected.lfactura || loading" *ngIf="!consulta">
                    <i class="fas fa-money-bill-alt mr-2"></i>Movimientos
                </button>
                <button class="btn btn-primary mr-1 px-4" [disabled]="loading" (click)="openHelp('Tarifas', 'xl')">
                    <i class="fas fa-calculator mr-2"></i>Tarifas
                </button>
                <button class="btn btn-danger mr-1" [disabled]="loading" (click)="darCheckOut()" *ngIf="!consulta">
                    <i class="fas fa-sign-out-alt mr-2"></i>Check-Out
                </button>

            </div>
        </div>
        <div class="divider"></div>
        <!-- BALANCE DE CADA CUENTA  -->
        <div class="row mx-0">
            <ng-container *ngFor="let cuenta of dataBalances;">
                <div class="card col mb-1 widget-chart widget-chart2 text-left card-btm-border" [ngClass]="{
                        'border-light': cuentaSelected.cCuenta !== cuenta.cCuenta,
                        'gradiente-danger': cuenta.lfactura,
                        'gradiente-success border-success': cuentaSelected.cCuenta === cuenta.cCuenta
                    }" (click)="seleccionarCuenta(cuenta)">
                    <div class="widget-chat-wrapper-outer">
                        <div class="widget-chart-content">
                            <div class="widget-title opacity-7 text-uppercase text-left">
                                Cuenta <strong>{{ cuenta.cCuenta }}</strong>
                            </div>
                            <div class="widget-numbers mt-0 fsize-4 mb-0 w-100">
                                <div class="text-right">
                                    <small class="opacity-5 pr-1">$</small>
                                    {{ cuenta.dbalance | number:'1.2-2' }}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </ng-container>
        </div>


        <div class="row d-flex justify-content-end">
            <!-- GRID CON EL DETALLE DE LA CUENTA SELECCIONADA -->
            <div class="col-12 animated fadeIn">
                <kendo-grid [data]="dataGrid" [selectable]="selectableSettings" [reorderable]="true" [resizable]="true"
                    [kendoGridSelectBy]="mySelectionKey" [selectedKeys]="mySelection" style="height:52vh;"
                    (dblclick)="openModal(modalMovto, 'xl')" (selectedKeysChange)="onSelectedKeysChange($event)">
                    <ng-template kendoGridToolbarTemplate *ngIf="!consulta">
                        <div class="row">
                            <div class="col d-flex justify-content-start" *ngIf="!cuentaSelected.lfactura">
                                <button class="btn btn-warning px-4 m-1" (click)="seleccionMultiple()"
                                    *ngIf="dataGrid.length">
                                    <span *ngIf="!flagSeleccionar">Seleccionar</span>
                                    <span *ngIf="flagSeleccionar">Terminar</span>
                                </button>
                                <button class="btn btn-secondary px-4 m-1" (click)="transferMovto(modalDetMov)"
                                    [disabled]="!movtoSelect.length">Transferencia
                                </button>
                                <button class="btn btn-secondary px-5 m-1" (click)="ajusteMovto(modalDetMov)"
                                    [disabled]="!movtoSelect.length">Ajuste
                                </button>
                                <button class="btn btn-secondary px-5 m-1" (click)="splitMovto(modalDetMov)"
                                    [disabled]="!movtoSelect.length"> Split
                                </button>
                            </div>
                            <div class="col d-flex justify-content-end">
                                <button class="btn btn-primary m-1" (click)="pagarCuenta()"
                                    [disabled]="cuentaSelected.lfactura && !dataGrid.length || loading"
                                    *ngIf="!cuentaSelected.lfactura">
                                    <i class="fas fa-credit-card mr-2"></i>Pagar Cuenta
                                </button>
                                <button class="btn btn-danger m-1" (click)="abrirCuenta();"
                                    [disabled]="!cuentaSelected.lfactura || loading">
                                    <i class="fas fa-lock-open mr-2"></i>Abrir Cuenta
                                </button>
                            </div>
                        </div>
                    </ng-template>
                    <ng-container *ngIf="dataGrid.length !== 0">
                        <kendo-grid-checkbox-column showSelectAll="true" *ngIf="flagSeleccionar" width="50">
                        </kendo-grid-checkbox-column>
                        <kendo-grid-column field="ttf" title="TF" width="60"></kendo-grid-column>
                        <kendo-grid-column field="tfecha" title="Fecha" width="120"></kendo-grid-column>
                        <kendo-grid-column field="tcod" title="Cod." width="70"></kendo-grid-column>
                        <kendo-grid-column field="tvouc" title="Voucher" width="90"></kendo-grid-column>
                        <kendo-grid-column field="tdesc" title="Descripción"></kendo-grid-column>
                        <kendo-grid-column field="tcargo" title="Cargos" width="100" class="text-right">
                            <ng-template kendoGridCellTemplate let-dataItem>
                                {{ dataItem.tcargo | number:'1.2-2' }}
                            </ng-template>
                        </kendo-grid-column>
                        <kendo-grid-column field="tabono" title="Abonos" width="100" class="text-right">
                            <ng-template kendoGridCellTemplate let-dataItem>
                                {{ dataItem.tabono | number:'1.2-2' }}
                            </ng-template>
                        </kendo-grid-column>
                        <kendo-grid-column field="tbalan" title="Balance" width="100"
                            [class]="{'text-danger': tbalan < 0, 'text-right': cuentaSelected.cCuenta }">
                            <ng-template kendoGridCellTemplate let-dataItem>
                                {{ dataItem.tbalan | number:'1.2-2' }}
                            </ng-template>
                        </kendo-grid-column>
                        <kendo-grid-column field="tnotas" title="Notas" width="160"></kendo-grid-column>
                        <kendo-grid-column field="ttransf" title="T" width="55" class="text-right"></kendo-grid-column>
                        <kendo-grid-column field="tcancel" title="A" width="55"></kendo-grid-column>
                        <kendo-grid-column field="texentos" title="Exentos" width="90" class="text-right">
                            <ng-template kendoGridCellTemplate let-dataItem>
                                {{ dataItem.texentos | number:'1.2-2' }}</ng-template>
                        </kendo-grid-column>
                    </ng-container>
                    <ng-template kendoGridNoRecordsTemplate>
                        {{ noRecords }}
                    </ng-template>
                </kendo-grid>
            </div>
            <!-- GRID CON EL DETALLE DE LA CUENTA SELECCIONADA -->
            <div class="col-6 col-md-5 col-lg-4 col-xl-3 animated fadeIn mb-1" *ngIf="dataTtmon.length">
                <kendo-grid [data]="dataTtmon" [selectable]="true" [reorderable]="true" [resizable]="true">
                    <ng-container *ngIf="dataTtmon.length !== 0">
                        <kendo-grid-column field="tmon" title="Mon." width="60">
                            <ng-template kendoGridFooterTemplate let-column>
                                <strong class="text-primary" *ngIf="cuentaSelected.cFp">
                                    {{ cuentaSelected.cFp }}
                                </strong>
                            </ng-template>
                        </kendo-grid-column>
                        <kendo-grid-column field="tmonto" title="Balance" width="80"
                            [class]="{'text-danger': tmonto < 0, 'text-right': cuentaSelected.cCuenta }">
                            <ng-template kendoGridCellTemplate let-dataItem>
                                {{ dataItem.tmonto | number:'1.2-2' }}
                            </ng-template>
                        </kendo-grid-column>
                    </ng-container>
                    <ng-template kendoGridNoRecordsTemplate>
                        {{ norecords }}
                    </ng-template>
                </kendo-grid>
            </div>
        </div>
    </ng-container>

    <!-- BUSQUEDA DE HUESPED -->
    <div class="animated fadeIn" *ngIf="flagBuscarHuesped">
        <app-buscar (resultFolio)="resultHuesped($event)">
            <!-- <strong><h5>Huespedes en Casa</h5></strong>  -->
        </app-buscar>
    </div>
</div>

<!-- AUTORIZACIÓN -->
<app-authorization (user)="userAuth($event);" (close)="noCancelarMovto();" *ngIf="flagUserAuth">
</app-authorization>

<!--Modal-->
<ng-template #modalHelp let-c="close" let-d="dismiss">
    <div class="modal-header">
        <button class="close" aria-label="Close" (click)="c()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <div class="animated fadeIn" [ngSwitch]="loadApp">
            <!-- <app-huesped [folio]="folioSelected" *ngSwitchCase="'Huesped'"></app-huesped> -->
            <app-mensajes [consulta]="consulta" [noFolio]="folioSelected" *ngSwitchCase="'Mensajes'"></app-mensajes>
            <app-notas [consulta]="consulta" [noFolio]="folioSelected" *ngSwitchCase="'Notas'"></app-notas>
            <app-requerimientos [consulta]="consulta" [folio]="folioSelected" (close)="getSaldos()"
                *ngSwitchCase="'Requerimientos'">
            </app-requerimientos>
            <app-cargos [consulta]="consulta" [folio]="folioSelected" (close)="getSaldos()" *ngSwitchCase="'Cargos'">
            </app-cargos>
            <app-cuentas [consulta]="consulta" [folio]="folioSelected" *ngSwitchCase="'Cuentas'"></app-cuentas>
            <app-cxc [consulta]="consulta" [folio]="folioSelected" *ngSwitchCase="'Cxc'"></app-cxc>
            <app-tarifas [consulta]="consulta" [folio]="folioSelected" *ngSwitchCase="'Tarifas'"></app-tarifas>
        </div>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c();; actionsNotification(folioSelected.hfolio);">
            Cerrar
        </button>
    </div>
</ng-template>

<!-- DETALLE DE MOVIMIENTO POR CODIGO, SE ACTIVA DANDOLE DOBLE CLICK A UN REGISTRO DE LA GRID -->
<ng-template #modalDetMov let-c="close" let-d="dismiss">
    <div class="modal-header">
        <button class="close" aria-label="Close" (click)="c();">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-detalle-movimiento [folio]="folioSelected" [action]="action" (transferir)="transferirMovto($event);"
            [cuenta]="cuentaSelected" [movimiento]="movtoSelect" *ngIf="!flagEntradaMovimiento">
        </app-detalle-movimiento>
        <!-- ENTRADA DE MOVIMIENTOS -->
        <app-entrada-movimientos (result)="resultMovto($event, c)" [entrada]="flagEntradaMovimiento"
            [pagar]="flagPagarCuenta" [movimientos]="dataMovimientos" [cuenta]="cuentaSelected" [folio]="folioSelected"
            [ajuste]="action" [movtoAjuste]="movtoSelect[0]" *ngIf="flagEntradaMovimiento">
        </app-entrada-movimientos>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c();">Cerrar</button>
    </div>
</ng-template>

<ng-template #modalFact let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6 class="modal-title"> Selección de R.F.C. </h6>
        <button class="close" aria-label="Close" (click)="c()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-factura-checkout [facturar]="true" [movtos]="dataGrid" [folio]="folioSelected"
            (finished)="resultFactura($event); c();">
        </app-factura-checkout>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c();">Cerrar</button>
    </div>
</ng-template>

<ng-template #modalMovto let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6 class="modal-title">Movimiento por código</h6>
        <button class="close" aria-label="Close" (click)="c();">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-movimiento-codigo [movimiento]="movtoSelect"></app-movimiento-codigo>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c();">Cerrar</button>
    </div>
</ng-template>